//http://homofaciens.de/technics-physical-computing-set01_en.htm

//Driving a unipolar stepper motor type 28BYJ-48

//Connect kathode (-) of motor board to GND of Arduino
//Connect anode (+) of motor board to +5V of Arduino
//Connect In1 of motor board to pin 2 of Arduino
//Connect In2 of motor board to pin 3 of Arduino
//Connect In3 of motor board to pin 4 of Arduino
//Connect In4 of motor board to pin 5 of Arduino


//Define pin number the LED is connected to
#define MOTOR_01_PIN  2
#define MOTOR_02_PIN  3
#define MOTOR_03_PIN  4
#define MOTOR_04_PIN  5

int motorDelay = 10;

int i;
int j;

void setup() {                 //This code is executed whenever the board is turned on or the reset button is pressed
  //Switch all motor pins to output mode
  pinMode(MOTOR_01_PIN, OUTPUT);
  pinMode(MOTOR_02_PIN, OUTPUT);
  pinMode(MOTOR_03_PIN, OUTPUT);
  pinMode(MOTOR_04_PIN, OUTPUT);

  motorDelay = 50;
}

void loop() {                       //This loop runs forever

  //Turn motor pins on in sequence

    motorDelay = 50;
    //Clockwise
    for(i=2; i<48; i++){
      //Turn pin on
      digitalWrite(MOTOR_01_PIN, HIGH);
      digitalWrite(MOTOR_04_PIN, LOW);
      delay(motorDelay);
      digitalWrite(MOTOR_02_PIN, HIGH);
      digitalWrite(MOTOR_01_PIN, LOW);
      delay(motorDelay);
      digitalWrite(MOTOR_03_PIN, HIGH);
      digitalWrite(MOTOR_02_PIN, LOW);
      delay(motorDelay);
      digitalWrite(MOTOR_04_PIN, HIGH);
      digitalWrite(MOTOR_03_PIN, LOW);
      delay(motorDelay);
    }

    //Counterclockwise
    for(i=2; i<48; i++){
      //Turn pin on
      digitalWrite(MOTOR_01_PIN, HIGH);
      digitalWrite(MOTOR_02_PIN, LOW);
      delay(motorDelay);
      digitalWrite(MOTOR_04_PIN, HIGH);
      digitalWrite(MOTOR_01_PIN, LOW);
      delay(motorDelay);
      digitalWrite(MOTOR_03_PIN, HIGH);
      digitalWrite(MOTOR_04_PIN, LOW);
      delay(motorDelay);
      digitalWrite(MOTOR_02_PIN, HIGH);
      digitalWrite(MOTOR_03_PIN, LOW);
      delay(motorDelay);
    }

    motorDelay = 5;
    //Counterclockwise
    for(i=2; i<120; i++){
      //Turn pin on
      digitalWrite(MOTOR_01_PIN, HIGH);
      digitalWrite(MOTOR_02_PIN, LOW);
      delay(motorDelay);
      digitalWrite(MOTOR_04_PIN, HIGH);
      digitalWrite(MOTOR_01_PIN, LOW);
      delay(motorDelay);
      digitalWrite(MOTOR_03_PIN, HIGH);
      digitalWrite(MOTOR_04_PIN, LOW);
      delay(motorDelay);
      digitalWrite(MOTOR_02_PIN, HIGH);
      digitalWrite(MOTOR_03_PIN, LOW);
      delay(motorDelay);
    }

    motorDelay = 2;
    //Counterclockwise
    for(i=2; i<400; i++){
      //Turn pin on
      digitalWrite(MOTOR_01_PIN, HIGH);
      digitalWrite(MOTOR_02_PIN, LOW);
      delay(motorDelay);
      digitalWrite(MOTOR_04_PIN, HIGH);
      digitalWrite(MOTOR_01_PIN, LOW);
      delay(motorDelay);
      digitalWrite(MOTOR_03_PIN, HIGH);
      digitalWrite(MOTOR_04_PIN, LOW);
      delay(motorDelay);
      digitalWrite(MOTOR_02_PIN, HIGH);
      digitalWrite(MOTOR_03_PIN, LOW);
      delay(motorDelay);
    }



}
