//http://homofaciens.de/technics-physical-computing-set01_en.htm

//LCD GND to Arduino GND
//LCD VCC to Arduino +5V
//LCD SCL to Arduino A5
//LCD SDA to Arduino A4

//LEDs with anode (long pin) to Arduino pins 5 - 10
//cathodes of LEDs to Arduino GND through 220 ohms resistor

#include <Wire.h>
#include <LiquidCrystal_I2C.h>


//Define pin number the LEDs are connected to
#define LED_01                 13
#define LED_02                 12
#define LED_03                 11
#define LED_04                 10
#define LED_05                  9
#define LED_06                  8
#define LED_07                  7
#define LED_08                  6
#define LED_09                  5

int LEDpause = 100;

LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);


void setup() {                 //This code is executed whenever the board is turned on or the reset button is pressed

  pinMode(LED_01, OUTPUT);
  pinMode(LED_02, OUTPUT);
  pinMode(LED_03, OUTPUT);
  pinMode(LED_04, OUTPUT);
  pinMode(LED_05, OUTPUT);
  pinMode(LED_06, OUTPUT);
  pinMode(LED_07, OUTPUT);
  pinMode(LED_08, OUTPUT);
  pinMode(LED_09, OUTPUT);

  lcd.begin(16,2);               // initialize the lcd

  lcd.home ();                   // go home
  lcd.print("Computing on Bat");
  lcd.setCursor ( 0, 1 );        // go to the next line
  lcd.print ("                ");
  delay ( 1000 );

}

void loop() {                       //This loop runs forever

  digitalWrite(LED_01, LOW);
  digitalWrite(LED_09, HIGH);
  delay(LEDpause);
  digitalWrite(LED_02, LOW);
  digitalWrite(LED_01, HIGH);
  delay(LEDpause);
  digitalWrite(LED_03, LOW);
  digitalWrite(LED_02, HIGH);
  delay(LEDpause);
  digitalWrite(LED_04, LOW);
  digitalWrite(LED_03, HIGH);
  delay(LEDpause);
  digitalWrite(LED_05, LOW);
  digitalWrite(LED_04, HIGH);
  delay(LEDpause);
  digitalWrite(LED_06, LOW);
  digitalWrite(LED_05, HIGH);
  delay(LEDpause);
  digitalWrite(LED_07, LOW);
  digitalWrite(LED_06, HIGH);
  delay(LEDpause);
  digitalWrite(LED_08, LOW);
  digitalWrite(LED_07, HIGH);
  delay(LEDpause);
  digitalWrite(LED_09, LOW);
  digitalWrite(LED_08, HIGH);
  delay(LEDpause);

/*
  digitalWrite(LED_01, LOW);
  digitalWrite(LED_09, HIGH);
  delay(LEDpause * 4);
  digitalWrite(LED_04, LOW);
  digitalWrite(LED_01, HIGH);
  delay(LEDpause * 4);
  digitalWrite(LED_07, LOW);
  digitalWrite(LED_04, HIGH);
  delay(LEDpause * 4);

  digitalWrite(LED_02, LOW);
  digitalWrite(LED_07, HIGH);
  delay(LEDpause * 4);
  digitalWrite(LED_05, LOW);
  digitalWrite(LED_02, HIGH);
  delay(LEDpause * 4);
  digitalWrite(LED_08, LOW);
  digitalWrite(LED_05, HIGH);
  delay(LEDpause * 4);


  digitalWrite(LED_03, LOW);
  digitalWrite(LED_08, HIGH);
  delay(LEDpause * 4);
  digitalWrite(LED_06, LOW);
  digitalWrite(LED_03, HIGH);
  delay(LEDpause * 4);
  digitalWrite(LED_09, LOW);
  digitalWrite(LED_06, HIGH);
  delay(LEDpause * 4);
*/



  digitalWrite(LED_09, HIGH);


  int a, b, c;
  char buffer[20];


  a = random(100);
  b = random(100);
  c = a + b;

  sprintf(buffer, "% 3d + % 3d = % 3d ", a, b, c);

  lcd.setCursor ( 0, 1 );        // go to the next line
  lcd.print (buffer);


}
